/*
                    ascii.c
		---------------
	primitives for ascii-art conversions
*/

#include   <stdio.h>
#include   <stdlib.h>
#include   <string.h>
#include   <time.h>

#include   "image.h"

/*::------------------------------------------------------------------::*/
/*
 *	a very bad first trial ; print to stdout if fname is "-"
 */
int
Image_ascii_0(Image_Desc *src, char *fname, int largeur)
{
int	x, y, r, g, b;
int	val, foo;
char	lettres[] = " .,:=oxX";
int	nb_lettres;
float	fstep;
FILE 	*fp;

/*
 *    GROS BUG ICI !!!
 */
fstep = (float)src->width / (float)largeur;

fprintf(stderr, "ascii 0: dim-img %d x %d  largeur %d fstep = %f\n",
			src->width, src->height, largeur, fstep);
nb_lettres = strlen(lettres);

exit(1);

if (strcmp(fname, "-"))
	{
	fprintf(stderr, "writing ascii_0 to file %s\n", fname);
	fp = fopen(fname, "w");
	if (fp==NULL)
		{
		perror("ascii_0");	exit(8);
		}
	}
else
	{
	fprintf(stderr, "writing ascii_0 to stdout\n");
	fp = stdout;
	}

for (y=0; y<src->height; y+=10)
	{
	for (x=0; x<src->width; x+=10)
		{
		Image_getRGB(src, x, y, &r, &g, &b);
		val = (r+g+b)/3;
		foo = (val * nb_lettres) / 256;
		putc(lettres[foo], fp);
		printf("%c", lettres[foo]);
		}
	putc('\n', fp);		fflush(fp);
	printf("\n");
	fprintf(stderr, "line %d on %d\n", y, src->height);
	}

if (fp != stdout)	fclose(fp);

return FUNC_IS_BETA;
}
/*::------------------------------------------------------------------::*/
/*
 *	a very bad second trial / need a _lot_ of work
 *
 *  4 Mai 2002: reprise en main, pour faire plaisir  Ant-1.
 * 25 Avr 2007: oh, un coredump sur une image 479x364 !
 */
int
Image_ascii_1(Image_Desc *src, char *nom, int width, char *cars)
{
int	step, x, y, count;
int	foo, sx, sy, sr, sg, sb, xp, yp;
int	nb_letters;
FILE	*fp;

if (strcmp(nom, "-"))
	{
	fprintf(stderr, "writing ascii_1 to file '%s'\n", nom);
	fp = fopen(nom, "w");
	if (fp==NULL)
		{
		perror("ascii_1");	exit(8);
		}
	}
else
	{
	fprintf(stderr, "writing ascii_1 to stdout\n");
	fp = stdout;
	}

step = src->width / width;
nb_letters = strlen(cars);

#if DEBUG_LEVEL
fprintf(stderr, "Image_ascii_1:\n");
fprintf(stderr, "pict width = %d  ascii width = %d\n", src->width, width);
fprintf(stderr, "step = %d  nb_letters = %d\n", step, nb_letters);
fflush(stderr);		/* print just before dumping core */
#endif

for (y=0; y<src->height; y+=step)
	{
	for (x=0; x<src->width; x+=step)
		{
		sr = sg = sb = 0;
		count = 0;

		for (sx=0; sx<step; sx++)
		    {
		    xp = x + sx;
		    for (sy=0; sy<step; sy++)
			{
			yp = y + sy;
			if (xp<src->width && yp<src->height)
			    {
			    sr += (src->Rpix[yp])[xp];
			    sg += (src->Gpix[yp])[xp];
			    sb += (src->Bpix[yp])[xp];
			    count++;
			    }
			}
		    }

		foo = (sr+sg+sb) / (count*3);
		foo = foo % nb_letters;
		putc(cars[foo], fp);
		}
	putc('\n', fp);
	}

fprintf(stderr, "count is %d\n", count);

if (fp != stdout)	fclose(fp);

return FUNC_IS_BETA;
}
/*::------------------------------------------------------------------::*/
/*
 * nouvelle tentative, 30 septembre 2008 - ave St Exupery
 */
static void ligne(FILE *f, int n)
{
int	foo;
putc('+', f);
for (foo=0; foo<n; foo++)	putc('-', f);
putc('+', f);	putc('\n', f);
}
int
Image_ascii_2(Image_Desc *src, char *fname,
			int lcar, int hcar, char *cars, int flags)
{
int		imgw, imgh;
FILE		*fp;
time_t		temps;
char		*cptr;
int		cx, cy, px, py, vp;
double		kx, ky, kc;
int		car, tcars, l2;

if (NULL==cars)
	{
	cars = "Toto Est Ivre-Mort";
	}

imgw = src->width;
imgh = src->height;
#if DEBUG_LEVEL
fprintf(stderr, "%s: img %dx%d  txt %dx%d\n", __func__,
			imgw, imgh, lcar, hcar);
#endif

/* preparation du flux de sortie */
if (strcmp(fname, "-"))
	{
	fprintf(stderr, "writing ascii_2 to file '%s'\n", fname);
	fp = fopen(fname, "w");
	if (fp==NULL)
		{
		perror("ascii_2");	exit(8);
		}
	}
else
	{
	fprintf(stderr, "writing ascii_2 to stdout\n");
	fp = stdout;
	}

if (0 == hcar)
	{
	/* caller have asked for a default value */
	hcar = (lcar*6) / 9;
	}

temps = time(NULL); cptr = ctime(&temps);
l2 = strlen(cptr)-1;
if (l2 >= 0)
	cptr[l2] = '\0';

if (flags & 2)
	{
	fprintf(fp, "la conversion est %dx%d -> %dx%d\n",
					imgw, imgh, lcar, hcar);
	fprintf(fp, "fait le '%s'\n", cptr);
	}

tcars = strlen(cars);
kc = (double)tcars / 256.0;
kx = (double)imgw / (double)lcar;
ky = (double)imgh / (double)hcar;
if (!(flags&1))
	{
	fprintf(fp, "%d glyphes, kc vaut %f\n", tcars, kc);
	fprintf(fp, "les coefficients sont %f et %f\n", kx, ky);
	fflush(fp);
	}

if (flags & 1)	ligne(fp, lcar);
/* OK, now processing of the picture */
for (cy=0; cy<hcar; cy++)
	{
	if (!(flags & 1))
		fprintf(fp, "%3d ", cy);
	if (flags & 1)	putc('|', fp);
	py = (int)(ky*(double)cy);
	for (cx=0; cx<lcar; cx++)
		{
		px = (int)(kx*(double)cx);
		vp = Image_R_pixel(src, px, py);
		car = cars[(int)((kc*(double)vp))];
		putc(car, fp);
		}
	if (flags & 1)	putc('|', fp);
	fprintf(fp, "\n");
	}
if (flags & 1)	ligne(fp, lcar);

/* yo we now have a good file on disk */
if (fp != stdout)	fclose(fp);

return FUNC_IS_BETA;
}
/*::------------------------------------------------------------------::*/
