/*
 *    aciiart.c - new 28 juillet 2008 - ave St Exupery
 */

#include  <stdio.h>
#include  <stdlib.h>
#include  <unistd.h>
#include  <string.h>
#include  "image.h"

/*::------------------------------------------------------------------::*/
int Image_asciiart_0(Image_Desc *src)
{
Image_Desc	*tmp;
int		foo, erreurs;
int		x, y, v;
char		trame[] = "#.    -+  |   oO";

#if DEBUG_LEVEL
fprintf(stderr, "%s (%p)  strlen(\"%s\") is %d\n", __func__, src,
				 trame, strlen(trame));
#endif

if ( NULL == (tmp=Image_clone(src, 1)) )
	{
	fprintf(stderr, "something wrong while cloning %p\n", src);
	abort();
	}

Image_seuil_RGB(tmp, tmp, 128, 128, 128);
foo = Image_2x2_contours_0(tmp);
Image_TGA_save("asciiart_0.tga", tmp, 0);

erreurs = 0;
for (y=0; y<tmp->height-1; y+=2)
	{
	for (x=0; x<tmp->width-1; x+=2)
		{
		v =  (
			( Image_R_pixel(tmp, x+1, y+1) ? 0 : 1 ) | 
			( Image_R_pixel(tmp, x  , y+1) ? 0 : 2 ) | 
			( Image_R_pixel(tmp, x+1, y  ) ? 0 : 4 ) | 
			( Image_R_pixel(tmp, x  , y  ) ? 0 : 8 ) ) ;
		putchar(trame[v]);
		}
	printf("\n");
	}
if (erreurs)
	fprintf(stderr, "%s: %d bad pixels\n", __func__, erreurs);

return FUNC_IS_BETA;
}
/*::------------------------------------------------------------------::*/
/* autre methode */
int Image_asciiart_1(Image_Desc *src, char *pattern, int reverse)
{
Image_Desc	*tmp, *dst;
int		foo, erreurs, x, y, bits, ascii;
char		def_pattern[] = "0123456789abcdef";
char		*ligne;

#if DEBUG_LEVEL
fprintf(stderr, "%s of %p is not ready for the primetime\n", __func__, src);
#endif

if (NULL == pattern)
	{
	fprintf(stderr, "%s: using the default pattern\n", __func__);
	pattern = def_pattern;
	}
if (16 != (foo=strlen(pattern)))
	{
	fprintf(stderr, "%s: bad pattern length %d\n", __func__, foo);
	return STRING_ERROR;
	}
if ( NULL == (tmp=Image_clone(src, 1)) )
	{
	fprintf(stderr, "%s: memory error\n", __func__);
	abort();
	}
if ( NULL == (dst=Image_clone(src, 1)) )
	{
	fprintf(stderr, "%s: memory error\n", __func__);
	abort();
	}

if (reverse)
	{
	fprintf(stderr, "hop, on reverse l'image :)\n");
	Image_negate(src, tmp);
	}
else	{
	fprintf(stderr, "bah non, on reverse pas...\n");
	Image_copy(src, tmp);
	}

Image_clear(dst, 0, 0, 0);
foo = Image_2x2_contours_1(tmp, dst);
#if DEBUG_LEVEL > 1
Image_TGA_save("asciiart_1.tga", tmp, 0);
#endif

fprintf(stderr, "le pattern est |%s|\n", pattern);

erreurs = 0;
for (y=0; y<dst->height-1; y+=1)
	{
	for (x=0; x<dst->width-1; x++)
		{
		bits = dst->Rpix[y][x];
		if (bits<0 || bits>15)
			{
			erreurs++;
			ascii = '?';
			}
		else
			ascii = pattern[bits];
		putchar(ascii);
		}
	putchar('\n');	
	}

if (erreurs)
	fprintf(stderr, "il y a %d erreurs\n", erreurs);

return FUNC_IS_BETA;
}
/*::------------------------------------------------------------------::*/
int Image_asciiart_2(Image_Desc *src, char *pattern, int param)
{
Image_Desc	*tmp;
int		foo;

fprintf(stderr, "%s: %p |%s| %d\n", __func__, src, pattern, param);

return FUNC_IS_ALPHA;
}
/*::------------------------------------------------------------------::*/
