/*
                    combine5.c
		    ----------

	dgrads linaires divers.
	avec des erreurs d'arrondi dedans.

*/

#include   <stdio.h>
#include   <stdlib.h>

#include   "image.h"

/*::------------------------------------------------------------------::*/
int
Image_combine_Vdegrade(Image_Desc *s1, Image_Desc *s2,
						Image_Desc *dst, int sens)
{
int	x, y, foo;
int	r1, g1, b1;
int	r2, g2, b2;
int	rd, gd, bd;
double	k, ka, kb;

if ( (foo=Image_compare_desc(s1, s2)) )
	{
	fprintf(stderr, "V degrade: sources err: %s\n", Image_err2str(foo));
	return foo;
	}

for (y=0; y<s1->height; y++)
	{
	k = (double)y/(double)s1->height;
	if (sens)	{ ka = k;	kb = 1.0 - ka; }
	else		{ kb = k;	ka = 1.0 - kb; }

	for (x=0; x<s1->width; x++)
		{
		Image_getRGB(s1, x, y, &r1, &g1, &b1);
		Image_getRGB(s2, x, y, &r2, &g2, &b2);
		rd = (int)((double)r1*ka+(double)r2*(kb));
		gd = (int)((double)g1*ka+(double)g2*(kb));
		bd = (int)((double)b1*ka+(double)b2*(kb));
		Image_plotRGB(dst, x, y, rd, gd, bd);
		}
	}

return OLL_KORRECT;
}
/*::------------------------------------------------------------------::*/
int
Image_combine_Hdegrade(	Image_Desc *s1, Image_Desc *s2,
						Image_Desc *dst, int sens)
{
int	x, y, foo;
int	r1, g1, b1;
int	r2, g2, b2;
int	rd, gd, bd;
double	k, ka, kb;

if ( (foo=Image_compare_desc(s1, s2)) )
	{
	fprintf(stderr, "H degrade: sources err: %s\n", Image_err2str(foo));
	return foo;
	}

for (x=0; x<s1->width; x++)
	{
	k = (double)x/(double)s1->width;
	if (sens)	{ ka = k;	kb = 1.0-ka; }
	else		{ kb = k;	ka = 1.0-kb; }
	for (y=0; y<s1->height; y++)
		{
		Image_getRGB(s1, x, y, &r1, &g1, &b1);
		Image_getRGB(s2, x, y, &r2, &g2, &b2);
		rd = (int)((double)r1*ka+(double)r2*(kb));
		gd = (int)((double)g1*ka+(double)g2*(kb));
		bd = (int)((double)b1*ka+(double)b2*(kb));
		Image_plotRGB(dst, x, y, rd, gd, bd);
		}
	}

return OLL_KORRECT;
}
/*::------------------------------------------------------------------::*/
/*
 *	bon, l, on va essayer de faire a en diagonale, mais
 *	je pense que a ne va pas tre simple, car il faut traiter
 *	le cas des images qui ne sont pas carres...
 */
int
Image_combine_Ddegrade(	Image_Desc *s1, Image_Desc *s2,
						Image_Desc *dst, int sens)
{
int		foo;

fprintf(stderr, "%s:%d:%s: no such function or procedure\n",
		__FILE__, __LINE__, __func__);

if ( (foo=Image_compare_desc(s1, s2)) )
	{
	fprintf(stderr, "D degrade: sources err: %s\n", Image_err2str(foo));
	return foo;
	}

return FUNC_NOT_FINISH;
}
/*::------------------------------------------------------------------::*/
