/*

            DUMPPIX.C         outils d'affichage des pixels
			           (debugging tools)

*/

#include   <stdio.h>
#include   <string.h>
#include   <time.h>
#include   "image.h"

/*::------------------------------------------------------------------::*/

int
Image_dump_pixels_hexa(char *fname, Image_Desc *im,
			int x, int y, char *texte)
{
FILE    	*fp;
int     	lig, col;
U_BYTE  	r, g, b;

if (strcmp(fname, "-"))
	fprintf(stderr,"%s : must go to the file '%s' ?\n", __func__, fname);

fp = stdout;

fprintf(fp, "=====+====  @%p  [%s]  ====\n", im, texte);

fputs("     |", fp);
for (col=0; col<8; col++)
    {
    fprintf(fp, "  %4d ", col+x);
    }
fputs("\n", fp);

fputs("-----+\n", fp);

for (lig=0; lig<=12; lig++)
    {

    if (lig+y > im->width)
        continue;

    fprintf(fp, "%4d |", lig);

    for (col=0; col<=8; col++)
        {
        r = Image_R_pixel(im, col+x, lig+y);
        fprintf(fp, "   %02x  ", r);
        }
    fputs("\n     |", fp);
   
    for (col=0; col<=8; col++)
        {
        g = Image_G_pixel(im, col+x, lig+y);
        b = Image_B_pixel(im, col+x, lig+y);
        fprintf(fp, " %02x %02x ", g, b);
        }
    fputs("\n", fp);
    }

fputs("-----+\n", fp);

return OLL_KORRECT;
}
/*::------------------------------------------------------------------::*/
/*						nouveau 27 Juin 2001
 */
int
Image_dump_pixels_ascii(char *fname, Image_Desc *im,
			int x, int y, int w, int h,
			int seuil, char canal, char *texte)
{
int	lig, col, vpix;

#if DEBUG_LEVEL
fprintf(stderr, "dump_pixel_ascii: [%s] canal=%c seuil=%d\n",
				texte, canal, seuil);
#endif

vpix = 0;		/* shutting down a GCC warning */

printf("---[ %s ]---\n", texte);

for (lig=y; lig<y+h; lig++)
	{
	printf("%5d  ", lig);
	for (col=x; col<x+w; col++)
		{
		switch (canal)
			{
			case 'r':	case 'R':
				vpix = Image_R_pixel(im, lig, col);
				break; 	
			case 'g':	case 'G':
			case 'v':	case 'V':
				vpix = Image_G_pixel(im, lig, col);
				break; 	
			case 'b':	case 'B':
				vpix = Image_B_pixel(im, lig, col);
				break; 	
			}

		if (vpix < seuil)	putchar('.');
		else			putchar('*');
		}
	printf("\n");
	}
printf("\n");

fprintf(stderr, "OMG ! the filename '%s' is not used ?\n", fname);

return OLL_KORRECT;
}
/*::------------------------------------------------------------------::*/

