/*
                operations avec les images GIF
		==============================

	+-----------------------------------------------+
	|   nouvelle version Linux pour i386		|
	+-----------------------------------------------+

	Ce module _depend_ de la librairie GD. Unisys ayant fait
	le con, il n'est pas sur que ce module reste dans le
	package. Wait and See...

	Pour plus de details:  http://www.boutell.com/gd/

*/

#include  <stdio.h>
#include  <gd.h>

#include  "image.h"

/*::------------------------------------------------------------------::*/

int
Image_Gif_Overlay(Image_Desc *im, char *nomgif, int xp, int yp, int t)
{
int         x, y, gw, gh, xd, yd, pix;
int         r, g, b;
FILE        *fd;
gdImagePtr  gif;
int         transparent;
long        copied;

if ( (fd=fopen(nomgif, "rb")) == NULL )
    {
    fprintf(stderr, "Gif_Overlay: error opening GIF file %s\n", nomgif);
    return VERY_STRANGE;
    }

gif = gdImageCreateFromGif(fd);
fclose(fd);

gw = gdImageSX(gif);
gh = gdImageSY(gif);
transparent = gdImageGetTransparent(gif);

fprintf(stderr, "Gif_Overlay: image dimensions  %d x %d\n", gw, gh);
fprintf(stderr, "Gif_Overlay: transparence      %d\n", transparent);

copied = 0L;

for (y=0; y<gh; y++)
    {
    yd = y + yp;
    if ( (yd<0) || (yd>=im->height) )       continue;

    for (x=0; x<gw; x++)
        {
        xd = x + xp;
        if ( (xd<0) || (xd>=im->width) )        continue;

        pix = gdImageGetPixel(gif, x, y);

        if  ( ( (t>=0)  && (pix!=t) ) ||
              ( (t==-1) && (pix!=transparent) ) )
            {
            copied++;
            r = gdImageRed(gif, pix);
            g = gdImageGreen(gif, pix);
            b = gdImageBlue(gif, pix);

            Image_plotRGB(im, xd, yd, r, g, b);

            }

        }
    fprintf(stderr, "Gif_Overlay: line %4d / %4d  *  %8ld\r",
                                       y,    gh,     copied);
    }
fputs("\n", stderr);

return 0;
}
/*::------------------------------------------------------------------::*/
