/*
		IMG77B
		------

	interface pour le compilateur fortran g77
	quelques effets de base.
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	"image.h"

#include	"img77proto.h"

/*::------------------------------------------------------------------::*/
Image_Desc * Image77_return_slot(int numslot);  /* semi-private func  ::*/
/*::------------------------------------------------------------------::*/
int
img_water__(int *psrc, int *pdst, int *p_level)
{
int	foo;
Image_Desc *s = Image77_return_slot(*psrc);
Image_Desc *d = Image77_return_slot(*pdst);

if ( (s==NULL) || (d==NULL) )
	{
	fprintf(stderr, "img77: water: bad image number ?\n");
	return 9999;	/* was it a valid return value ? */
	}

foo = Image_water(s, d, *p_level);

return foo;
}
/*::------------------------------------------------------------------::*/
int
img_noise__(int *psrc, int *pdst, int *p_level)
{
int	foo;
Image_Desc *s = Image77_return_slot(*psrc);
Image_Desc *d = Image77_return_slot(*pdst);

if ( (s==NULL) || (d==NULL) )
	{
	fprintf(stderr, "img77: noise: bad image number ?\n");
	return 9999;	/* was it a valid return value ? */
	}

foo = Image_noise(s, d, *p_level);
return foo;
}
/*::------------------------------------------------------------------::*/
int
img_hipass__(int *psrc, int *pdst)
{
int	foo;

#if DEBUG_LEVEL > 1
fprintf(stderr, ">>>> %s : %d to %d\n", __func__, *psrc, *pdst);
#endif

Image_Desc *s = Image77_return_slot(*psrc);
Image_Desc *d = Image77_return_slot(*pdst);

foo = Image_filtre_passe_haut(s, d);

return foo;
}
/*::------------------------------------------------------------------::*/
int
img_prewitt__(int *psrc, int *pdst, int *prot)
{
int	foo, rotation;
Image_Desc *s = Image77_return_slot(*psrc);
Image_Desc *d = Image77_return_slot(*pdst);

rotation = *prot;
foo = Image_filtre_Prewitt(s, d, rotation);

return foo;
}
/*::------------------------------------------------------------------::*/
int
img_sobel__(int *psrc, int *pdst, int *prot)
{
int	foo, rotation;
Image_Desc *s = Image77_return_slot(*psrc);
Image_Desc *d = Image77_return_slot(*pdst);

rotation = *prot;
foo = Image_filtre_Sobel(s, d, rotation);

return foo;
}
/*::------------------------------------------------------------------::*/
int
img_sobel4__(int *psrc, int *pdst, int *prot)
{
fprintf(stderr, "%s:%d: sobel4 error\n", __FILE__, __LINE__);
/*
 *	BON, A QUOI JE PENSAIS POUR CETTE FONCTION ?
 */
return 9999;
}
/*::------------------------------------------------------------------::*/
int
img_mirror__(int *psrc, int *reserved)
{
Image_Desc *s = Image77_return_slot(*psrc);
Image_mirror(s, s, 0);
return 0;
}
/*::------------------------------------------------------------------::*/
int
img_updown__(int *psrc, int *reserved)
{
Image_Desc *s = Image77_return_slot(*psrc);
Image_upside_down(s, s, 0);
return 0;
}
/*::------------------------------------------------------------------::*/
