/*
		IMG77C
		------

	interface pour le compilateur fortran g77
	- sauvegardes en TGA
		. avec un nom 'numrique'
		. abec un nom alphabtique.
	- sauvegardes en PNM

*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"image.h"
#include	"img77proto.h"

/*::------------------------------------------------------------------::*/
Image_Desc * Image77_return_slot(int numslot);
/*::------------------------------------------------------------------::*/
/*
 *	pour etre compatible avec MessyDos, le numero d'image
 *	ne comportera que 5 digits a partir de la v 0.4.34
 */
int
tga_save_n__(int *pi, int *pn)
{
char		chaine[100];
int		foo;
Image_Desc	*image;

image = Image77_return_slot(*pi);
if (image==NULL)
	{
	return 1;
	}

sprintf(chaine, "im_%05d.tga", *pn);
#if DEBUG_LEVEL
fprintf(stderr, "### img77: saving image '%s'\n", chaine);
#endif

if (image == NULL)
	{
	fprintf(stderr, "img77: TGA_SAVE called, no image in memory.\n");
	exit(5);
	}

if ( (image->width < 1) || (image->height < 1) )
	{
	fprintf(stderr, "img77: tga_save_n: bad dimensions %d x %d\n",
						image->width, image->height);
	return IMAGE_TOO_SMALL;
	}

foo = Image_TGA_save(chaine, image, 0);

return foo;
}
/*::------------------------------------------------------------------::*/
/*
 *	in the name, 'S' stand for 'save' and 'a' for 'ascii filename
 */
int
img_ppm_sa__(int *pi, char *nom, int *pcomp, int sznom)
{
Image_Desc *img;
char	filename_buff[IMG_FILENAME_LEN+2];
char	*spacepos;
int	foo;

#if DEBUG_LEVEL
fprintf(stderr, "img77: ppm_s: #img %d   sznom %d\n", *pi, sznom);
#endif

img = Image77_return_slot(*pi);
if (img==NULL)
	{
	return 1;
	}

foo = IMG_FILENAME_LEN<sznom ? IMG_FILENAME_LEN : sznom;

strncpy(filename_buff, nom, IMG_FILENAME_LEN);
filename_buff[foo] = '\0';

spacepos = strchr(filename_buff, ' ');
if (spacepos != NULL)
	{
#if DEBUG_LEVEL
	fprintf(stderr, "space at %p\n", spacepos);
#endif
	*spacepos = '\0';
	}

#if DEBUG_LEVEL
for (foo=0; foo<9; foo++)
	fprintf(stderr, "%02x ", nom[foo]);
fprintf(stderr, "\n");
for (foo=0; foo<9; foo++)
	fprintf(stderr, "%02x ", filename_buff[foo]);
fprintf(stderr, "\n");
#endif

foo = Image_wr_ppm_0(filename_buff, img, 0);

#if DEBUG_LEVEL
fprintf(stderr, "img77: ppm sa: [%s] -> %d\n", filename_buff, foo);
#endif

return 0;
}
/*::------------------------------------------------------------------::*/
/*
 * in the function name, 'S' stand for 'save' and 'a' for 'ascii' filename
 */
int
img_tga_sa__(int *pi, char *nom, int *pcomp, int sznom)
{
Image_Desc *img;
char	filename_buff[IMG_FILENAME_LEN+2];
char	*spacepos;
int	foo;

#if DEBUG_LEVEL > 1
fprintf(stderr, "img77: tga sa: #img %d   sznom %d\n", *pi, sznom);
#endif

img = Image77_return_slot(*pi);
if (img==NULL)
	{
	fprintf(stderr, "img77: bad slot %d\n", *pi);
	return 1;
	}

foo = IMG_FILENAME_LEN<sznom ? IMG_FILENAME_LEN : sznom;
strncpy(filename_buff, nom, IMG_FILENAME_LEN);
filename_buff[foo] = '\0';

spacepos = strchr(filename_buff, ' ');
if (spacepos != NULL) *spacepos = '\0';

foo = Image_TGA_save(filename_buff, img, 0);
#if DEBUG_LEVEL > 1
fprintf(stderr, "img77: tga sa [%s] -> %d\n", filename_buff, foo);
#endif

return 0;
}
/*::------------------------------------------------------------------::*/
