/*
 *	img77f.c		Janvier 2006 - Colomiers
 *	--------
 *	A priori, interface avec les filtres.
 */

#include	<stdio.h>
#include	<stdlib.h>
#include	"image.h"

#include	"img77proto.h"

/*::------------------------------------------------------------------::*/
Image_Desc * Image77_return_slot(int numslot);  /* semi-private func  ::*/
/*::------------------------------------------------------------------::*/
int
img_filtr__(int *psrc, int *pdst, int *pmat)
{
int foo;
Image_Desc *src = Image77_return_slot(*psrc);
Image_Desc *dst = Image77_return_slot(*pdst);

if (*psrc == *pdst)
	{
	fprintf(stderr, "%s:%d: lissage: src & dst are the same image\n",
				 __FILE__, __LINE__);
	}

printf("\tIMG_FILTR: src=%d dst=%d\n", *psrc, *pdst);
foo = Image_convolueur3(src, dst, pmat);
printf("\tIMG_FILTR: retour=%d\n\n", foo);

return 0;
}
/*::------------------------------------------------------------------::*/
/* PROTO !!!  */
int
img_lissage__(int *psrc, int *pdst)
{
int foo;
Image_Desc *src = Image77_return_slot(*psrc);
Image_Desc *dst = Image77_return_slot(*pdst);

if (*psrc == *pdst)
	{
	fprintf(stderr, "%s:%d: lissage: src & dst are the same image\n",
				 __FILE__, __LINE__);
	}

foo = Image_lissage_3x3(src, dst);
#if DEBUG_LEVEL > 1
fprintf(stderr, "img77: 3x3 smooth returns %d\n", foo);
#endif
return foo;
}
/*::------------------------------------------------------------------::*/
/*
 * effacement des bords 
 */
void
img_razsd__(int *pim)
{
int	foo;

Image_Desc *img = Image77_return_slot(*pim);

#if DEBUG_LEVEL
fprintf(stderr, "%s : %d -> %p\n", __func__, *pim, img);
#endif

foo = Image_raz_sides(img);

#if DEBUG_LEVEL
fprintf(stderr, "     return %d\n", foo);
#endif
}
/*::------------------------------------------------------------------::*/
/* new 16 janvier 2006 @ Colomiers */
/* wrapper around Image_mix in combine2.c */
int
img_mix0__(int *ps1, int *ps2, int *pdst, float *pfoo)
{
Image_Desc *sr1 = Image77_return_slot(*ps1);
Image_Desc *sr2 = Image77_return_slot(*ps2);
Image_Desc *dst = Image77_return_slot(*pdst);
int	k, foo;

#if DEBUG_LEVEL > 1
fprintf(stderr, "%s : %s ( %d, %d, %d, %f )\n", __FILE__, __func__,
			*ps1, *ps2, *pdst, *pfoo);
#endif

if (sr1==NULL || sr2==NULL || dst==NULL)
	{
	fprintf(stderr, "img_mix0: %s: bad img number\n", __FILE__);
	exit(7);
	}

k = (int)(*pfoo * 10000.0);
#if DEBUG_LEVEL  > 1
fprintf(stderr, "  img_mix0: param = %f -> coef = %d\n", *pfoo, k);
#endif

foo = Image_mix(sr1, sr2, dst, k);
#if DEBUG_LEVEL > 1
fprintf(stderr, "  img_mix0 return %d\n", foo);
#endif
return -1; /* Gni ? */
}
/*::------------------------------------------------------------------::*/
