/*
		IMG77G
		------
	interface for working on a specified color component.
	
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"image.h"

#include	"img77proto.h"

/*::------------------------------------------------------------------::*/
Image_Desc * Image77_return_slot(int numslot);
/*::------------------------------------------------------------------::*/
int img_plt_r__(int *pimg, int *px, int *py, int *pval)
{
Image_Desc	*img;
int		foo;

/* XXX add sanity check here */
img = Image77_return_slot(*pimg);
if ( img==NULL )
	{
	fprintf(stderr, "img77: plt_r: bad image number ?\n");
	return 9999;
	}
foo = Image_plot_channel(img, 'R', *px, *py, *pval);

return 0;
}
/*::------------------------------------------------------------------::*/
int img_plt_g__(int *pimg, int *px, int *py, int *pval)
{
Image_Desc	*img;
int		foo;

/* XXX add sanity check here */
img = Image77_return_slot(*pimg);
if ( img==NULL )
	{
	fprintf(stderr, "img77: plt_g: bad image number ?\n");
	return 9999;
	}
foo = Image_plot_channel(img, 'G', *px, *py, *pval);

return 0;
}
/*::------------------------------------------------------------------::*/
int img_plt_b__(int *pimg, int *px, int *py, int *pval)
{
Image_Desc	*img;
int		foo;

/* XXX add sanity check here */
img = Image77_return_slot(*pimg);
if ( img==NULL )
	{
	fprintf(stderr, "img77: plt_b: bad image number ?\n");
	return 9999;
	}
foo = Image_plot_channel(img, 'B', *px, *py, *pval);

return 0;
}
/*::------------------------------------------------------------------::*/
/*
 *	plot in the alpha channel
 *	need more testing, I think.
 */
int img_plt_a__(int *pimg, int *px, int *py, int *pval)
{
Image_Desc	*img;
int		foo;

img = Image77_return_slot(*pimg);
if ( img==NULL )
	{
	fprintf(stderr, "img77: plt_a: bad image number ?\n");
	return 9999;
	}
if ( img->type != IMAGE_RGBA )
	{
	fprintf(stderr, "img77: plt_a: no alpha channel\n");
	return 9999;
	}

foo = Image_plot_channel(img, 'a', *px, *py, *pval);

return -1;
}
/*::------------------------------------------------------------------::*/
