/*
		IMG77I
		------
	interface vers 'bitblt.c'
	manipulations de sous images.

*/
#include	<stdio.h>
#include	<stdlib.h>
#include	"image.h"
#include	"img77proto.h"

/*::------------------------------------------------------------------::*/
Image_Desc * Image77_return_slot(int numslot);  /* semi-private func  ::*/
/*::------------------------------------------------------------------::*/
/*
 *	interface vers 'Image_put_rec' de 'bitblt.c'
 */
int
img_putimg__(int *psrc, int *pdest, int *ox, int *oy)
{
Image_Desc *src, *dest;
Image_Rect rect;
int	foo;

src = Image77_return_slot(*psrc);
/* 
 *	sanity control
 */
if (src == NULL)
	{
	fprintf(stderr, "img77: putimg: src is Null\n");
	exit(5);
	}

rect.x = 0;		rect.y = 0;
rect.h = src->height;	rect.w = src->width;

dest = Image77_return_slot(*pdest);
/* 
 *	sanity control
 */
if (dest == NULL)
	{
	fprintf(stderr, "img77: putimg: dest is Null\n");
	exit(5);
	}

foo = Image_put_rect(src, &rect, dest, *ox, *oy);

return 0;
}
/*::------------------------------------------------------------------::*/
/*
 *	interface vers 'Image_create_subimg' de 'bitblt.c'
 */

int Image77_addimg2slots(Image_Desc *img, int flag);
/* warning! this is a semi-private function */

int
img_subimg__(int *psrc, int *px, int *py, int *pw, int *ph)
{
Image_Desc	*src, *dest;
Image_Rect	rect;
int		newslot;

src = Image77_return_slot(*psrc);

if (src == NULL)
	{
	fprintf(stderr, "img77: subimg: src is Null\n");
	exit(5);
	}

rect.x	= *px;
rect.y	= *py;
rect.w	= *pw;
rect.h	= *ph;

/*
 *	extraction avec forage des pixels externes  noir.
 */
dest = Image_create_subimg(src, &rect, 0);
fprintf(stderr, "subimg is at %p\n", dest);

/*
 *	maintenant, il faut mettre cette _nouvelle_ image dans un slot.
 */
newslot = Image77_addimg2slots(dest, 1);
/*
 *	addimg2slot est une nouvelle fonction. son interface n'est
 *	pas vraiment bien dfinie. cordumps en vue...
 */

return newslot;
}
/*::------------------------------------------------------------------::*/
/* peinture d'un rectangle - new 17 janvier 2009 - ave St Exupery 	*/

void img_prect__(int *pdst, int *px, int *py, int *pw, int *ph,
				 int *pr, int *pg, int *pb)
{
Image_Desc	*dst;
Image_Rect	rect;
int		foo;

dst = Image77_return_slot(*pdst);
rect.x = *px;		rect.y = *py;
rect.w = *pw;		rect.h = *ph;

#if DEBUG_LEVEL
fprintf(stderr, "%s  %i -> %p\n", __func__, *pdst, dst);
/* XXX passing '__func__' as a char * is suspicious */
Image_dump_rect(&rect, (char *)__func__, 1);
#endif

foo = Image_paint_rect(dst, &rect, *pr, *pg, *pb);

}
/*::------------------------------------------------------------------::*/
/*
 *	il manque un 'get_rect' pour choper un morceau de l'image
 *	source qui rentre juste dans l'image destination ?
 */
