/*
 *	img77w.c
 *	--------
 */

#include        <stdio.h>
#include        <stdlib.h>
#include        <string.h>

#include        "image.h"
#include	"trigo.h"

#include        "img77proto.h"

/*::------------------------------------------------------------------::*/
Image_Desc * Image77_return_slot(int numslot);
/*::------------------------------------------------------------------::*/
/*
 *	rotation d'une image (warp1.c)    *     nouveau janvier 2006
 *	l'angle est en degres
 */
int
img_rot0__(int *psrc, int *pdst, float *pangle)
{
Image_Desc	*isrc, *idst;
float		angle;
int		foo;

isrc = Image77_return_slot(*psrc);
idst = Image77_return_slot(*pdst);

angle = *pangle;
#if DEBUG_LEVEL > 1
fprintf(stderr, "%s:%d: rotation de %d %p vers %d %p\n",
		__FILE__, __LINE__, *psrc, isrc, *pdst, idst);
fprintf(stderr, "%s:%d: angle = %f \n",
		__FILE__, __LINE__, angle);
#endif
if ( (isrc==NULL) || (idst==NULL) )
	{
	fprintf(stderr, "img77: img_rot0: bad image number ?\n");
	return 9999;	/* was it a valid return value ? */
	}

foo = Image_center_rotate(isrc, idst, (double)angle);

#if DEBUG_LEVEL > 1
fprintf(stderr, "%s:%d: retour rotation = %d \n",
		__FILE__, __LINE__, foo);
#endif

return foo;
}
/*::------------------------------------------------------------------::*/
/* new 10 janvier 2009 - avenue St Exupery */
int
img_sinw0__(int *psrc, int *pdst, float table[])
{
int		foo;
Image_Desc	*isrc, *idst;
double		dtable[6];

isrc = Image77_return_slot(*psrc);
idst = Image77_return_slot(*pdst);

#if DEBUG_LEVEL 
fprintf(stderr, "%s      %d -> (%p) -> %d\n",
			__func__, *psrc, table, *pdst);
#endif

for (foo=0; foo<6; foo++)
	{
	dtable[foo] = (double)table[foo];
#if DEBUG_LEVEL > 1
	fprintf(stderr, "sinw0    %3d    %9.6f   %9.6f\n",
				foo, table[foo], dtable[foo]);
#endif
	}

foo = Image_sinwave_0(isrc, idst, dtable);
fprintf(stderr, "Ok, got a %d\n", foo);

return foo;
}
/*::------------------------------------------------------------------::*/
/* new 10 janvier 2009 - avenue St Exupery */
int
img_sinw1__(int *psrc, int *pdst, float table[])
{
int		foo;
Image_Desc	*isrc, *idst;
double		dtable[6];

isrc = Image77_return_slot(*psrc);
idst = Image77_return_slot(*pdst);

for (foo=0; foo<6; foo++)
	{
	dtable[foo] = (double)table[foo];
#if DEBUG_LEVEL > 1
	fprintf(stderr, "sinw1    %3d    %9.6f   %9.6f\n",
				foo, table[foo], dtable[foo]);
#endif
	}

foo = Image_sinwave_1(isrc, idst, dtable);
fprintf(stderr, "in %s, got a %d\n", __func__, foo);

return foo;
}
/*::------------------------------------------------------------------::*/
