/*
                indexcol.c
		----------

*/

#include    <stdio.h>
#include    <stdlib.h>				/* for rand() */
#include    <string.h>
#include    <math.h>

#include    "image.h"

#undef DEBUG_LEVEL
#define DEBUG_LEVEL 1	

/*::------------------------------------------------------------------::*/
/*
 *	ajouter une couleur dans la palette de l'image 
 *	si OK
 *		retourne l'index de la couleur
 *	sinon
 *		retourne une valeur ngative
 */
int
Image_idxcol_add(Image_Desc *im, int r, int g, int b)
{
int	foo;

foo = im->idx_palette;

if (foo < 0)
	{
	fprintf(stderr, "IdxCol add: idx_palette < 0\n");
	return -1;
	}

if (foo > 255)
	{
	fprintf(stderr, "IdxCol add: palette is full\n");
	return -2;
	}

/* mettre les trois composantes dans la palette de l'image */
im->palette[1][foo] = (unsigned int)r & 0xff;
im->palette[2][foo] = (unsigned int)g & 0xff;
im->palette[3][foo] = (unsigned int)b & 0xff;
im->idx_palette++;

return foo;
}
/*::------------------------------------------------------------------::*/
int	Image_idxcol_clear(Image_Desc *im, int flag)
{

if (im->control != 0xdeadbeef)
	{
	fprintf(stderr, "idxcol clear: need Dead Beef!\n");
	return NOT_AN_IMAGE_DESC;
	}

im->idx_palette = 0;

return FUNC_NOT_FINISH;
}
/*::------------------------------------------------------------------::*/
int
Image_idxcol_plot(Image_Desc *im, int x, int y, int c)
{

#if DEBUG_LEVEL
fprintf(stderr, "IdxCol Plot: %5d %5d   %d\n", x, y, c);
#endif

/* verifier si on sort pas de l'image */
if (x<0 || y<0 || x>im->width || y>im->height)
	{
	fprintf(stderr, "IdxCol Plot: %d/%d out of image\n", x, y);
	return OUT_OF_IMAGE;
	}

/* vrifier si l'index de la couleur est dans les bornes */
if (c<0 || c>im->idx_palette)
	{
	fprintf(stderr, "IdxCol Plot: idxcol %d out of range\n", c);
	return BAD_COLOR_NUMBER;
	}

Image_plotRGB(im, x, y, 
		im->palette[0][c], im->palette[1][c], im->palette[2][c]);


return FUNC_NOT_FINISH;
}
/*::------------------------------------------------------------------::*/
