
/*
                    insert.c
	-------------------------------------------------------
        see also: bitblt.c
*/

#include   <stdio.h>
#include   "image.h"

/*::------------------------------------------------------------------::*/
/*
 *	'img' must be an image with alpha channel.
 *	the parameter 'factor' is currently not used.
 */
int
Image_insert_with_alpha(Image_Desc *img, Image_Desc *ins, int factor)
{
int	x, y, xi, yi, r, g, b, ri, gi, bi, a;
int	r2, g2, b2;
int	foo;

if ( (foo=Image_compare_desc(img, ins)) )
    {
    fprintf(stderr, "Insert with alpha: images are differents %d\n", foo);
    return foo;
    }

if ( img->Apix == NULL )
    {
    fprintf(stderr, "Insert with alpha: first image have NO alpha channel\n");
    return NO_ALPHA_CHANNEL;
    }

for (y=0; y<img->height; y++)
	{
	yi = y % ins->height;
	for (x=0; x<img->width; x++)
		{
		xi = x % ins->width;

		r = (img->Rpix[y])[x];
		g = (img->Gpix[y])[x];
		b = (img->Bpix[y])[x];

		ri = (ins->Rpix[yi])[xi];
		gi = (ins->Gpix[yi])[xi];
		bi = (ins->Bpix[yi])[xi];

		a = Image_A_pixel(img, x, y);

		/*
		 *   May be I have to check arithmetic overflows
		 *   in this calculs ?
		 */
		r2 = ((r * a) + (ri * (256-a))) / 256;
		g2 = ((g * a) + (gi * (256-a))) / 256;
		b2 = ((b * a) + (bi * (256-a))) / 256;
		/*
		 * OK, do a check...
		 */
		if (r2<0 || g2<0 || b2<0)
			return PIXEL_UNDERFLOW;	
		if (r2>255 || g2>255 || b2>255)
			return PIXEL_OVERFLOW;
		/*
		 *  but, but ? why not a clipping ?
		 */

		(img->Rpix[y])[x] = r2;
		(img->Gpix[y])[x] = g2;
		(img->Bpix[y])[x] = b2;
		}
	}

fprintf(stderr, "insert with alpha: work in progress\n");

return FUNC_IS_ALPHA;
}
/*::------------------------------------------------------------------::*/
/*
 *	en fait, c'est un peu le bordel dans les fonctions ayant un
 *	rapport avec le canal alpha. il faudrait essayer de faire une
 *	documentation precise, afin d'eviter les redondances.
 */
