/*
		text1.c
		-------
*/

#include  <stdio.h>
#include  <string.h>
#include  <unistd.h>
#include  <stdlib.h>

#include  "image.h"

/*::------------------------------------------------------------------::*/
/*
 *	parameter 'flags' is not used (reserved), must be 0.
 */
int
Image_txt1_box_0(Image_Desc *img, char *txt, int x, int y, int w, 
			RGBA *paper, RGBA *ink, int flags)
{
int		foo, lstr;
Image_Rect	rect;

if (flags != 0)
	{
	fprintf(stderr, "txt1 box 0: wrong flags: 0x%x\n", flags);
	return WRONG_FLAG;
	}
if (w < 0)
	{
	fprintf(stderr, "Ahem, w (%d) is < 0 ?\n", w);
	}

lstr = strlen(txt);

#if DEBUG_LEVEL > 1
fprintf(stderr, "Txt1 box 0: taille texte: %d\n", lstr);
Image_print_rgba("Papier", paper, 0);
Image_print_rgba("Encre",  ink, 0);
#endif

rect.x = x;	rect.y = y;
rect.h = 8 + (w*2);
rect.w = (lstr*8) + (w*2);

foo = Image_paint_rect(img, &rect, paper->r, paper->g, paper->b);
if (foo)
	Image_print_error("txt box 1: paint rect: ", foo);

foo = Image_trace_chaine_1(img, txt, x+w, y+w, "libimage.fonte", paper, ink);
if (foo)
	Image_print_error("txt box 1: trace chaine 0: ", foo);

foo = Image_draw_rect(img, &rect, ink->r, ink->g, ink->b);
if (foo)
	Image_print_error("txt box 1: draw rect: ", foo);

return FUNC_IS_BETA;
}
/*::------------------------------------------------------------------::*/
