/*
                tga.c
		=====

    for information about this file: oulala@chez.com

      7 Oct 2001: les problmes de boutisme sont rgls.
*/

#include  <stdio.h>
#include  <string.h>
#include  <stdlib.h>
#include  "image.h"   

/*::------------------------------------------------------------------::*/
#define LIBTGA_VERSION   "0.2.30"

typedef struct {

        U_BYTE  text_size;
        char    is_color_map;               /* 0=NO, 1=YES */
        char    type;                        
        U_WORD  map_start, map_length;      
        char    map_bits;                  
        U_WORD  x_start, y_start;
        U_WORD  width, height;
        char    bits;                     
        char    flags;                 

        } Tga_file_header;
/*::------------------------------------------------------------------::*/
int
Image_TGA_write_header(FILE *fp, Tga_file_header *head)
{
fwrite (&head->text_size, 1, 1, fp);
fwrite (&head->is_color_map, 1, 1, fp);
fwrite (&head->type, 1, 1, fp);
Image_basicIO_write_I_short(fp, head->map_start);
Image_basicIO_write_I_short(fp, head->map_length);
fwrite (&head->map_bits, 1, 1, fp);
Image_basicIO_write_I_short(fp, head->x_start);
Image_basicIO_write_I_short(fp, head->y_start);
Image_basicIO_write_I_short(fp, head->width);
Image_basicIO_write_I_short(fp, head->height);
fwrite (&head->bits, 1, 1, fp);
fwrite (&head->flags, 1, 1, fp);
return 0;
}
/*::------------------------------------------------------------------::*/
static void
fatal_error(char *txt)
{
fprintf(stderr, "TGA: FATAL ERROR: %s\n", txt);
exit(10);
}
/*::------------------------------------------------------------------::*/
static int
tga_pack_line(void)
{
/*
 *	___TODO___  compressed targa file !
 * 
 *	Novembre 2002: il serait temps de s'y mettre...
 *
 */
return -1;
}
/*::------------------------------------------------------------------::*/
/*
 *          il manque un grand nombre d'options
 *
 *          - la compression            ---> URGENT !!!
 *          - les images a palettes
 */
int
Image_TGA_save(char *nom, Image_Desc *img, int compress)
{
int                 ltxt, line, foo;
Tga_file_header     head;
FILE                *fp;
U_BYTE              *Rptr, *Gptr, *Bptr, *Aptr;
U_BYTE              *buffer, *ptr;

if (nom == NULL)    fatal_error("save image: name ptr is NULL");
if (img == NULL)    fatal_error("save image: descriptor is NULL");

/* 5 Dec 2001: add a check on img */
if (img->control != 0xdeadbeef)
	{
	fprintf(stderr, "TGASAVE: need Dead Beef!\n");
	return NOT_AN_IMAGE_DESC;
	}
/*
 *	mais a marche pas  tous les coups. il faudrait pouvoir tester si
 *	le pointeur 'img' est cohrent, mais je sais pas comment faire...
 */

/*
	10 Aout 2000: si le nom est "-", alors on ecrit le fichier
		sur STDOUT ce qui permet(tra) de faire des CGI :)
 */
if (strcmp("-", nom))
	{
	if ( (fp=fopen(nom, "wb")) == NULL )
	    fatal_error("save image: err fopen");
	}
else
	{
	fp = stdout;
	}

ltxt = strlen(img->comment);
/* FIXME must check the length of ze comment */

#if DEBUG_LEVEL
fprintf(stderr, "text size = %d\n", ltxt);
if (ltxt)
    fprintf(stderr, "    [%s]\n", img->comment);
#endif

/*      first, we populate the file header...				*/

head.text_size   = ltxt;
head.x_start     = head.y_start = 0;
head.width       = img->width;
head.height      = img->height;

head.flags       = 0;                   /* XXX  a preciser ... */

#if DEBUG_LEVEL
fprintf(stderr, "TGASAVE: img@ %p  nb planes: %d\n", img, img->nb_planes);
#endif

switch (img->nb_planes)
    {
    case    1:              /* images en niveau de gris */
        fputs("*** saving gray level image\n", stderr);
        head.type = 3;
        head.bits = 8;
        break;

    case    3:
        head.type = 2;                  /* uncompressed RGB image	*/
        head.bits = 24;               
        head.is_color_map = 0;          /*      No			*/
        head.map_start = 0;             /*      Color			*/
        head.map_length = 0;            /*      Map			*/
	head.map_bits = 0;		/*	?   (Aout 1999)		*/
        break;

    case    4:
#if DEBUG_LEVEL
        fputs("*!* saving image with alpha channel\n", stderr);
#endif
        head.type = 2;                  /* uncompressed RGB image with alpha */
        head.bits = 32;               
        head.is_color_map = 0;          /*      No			*/
        head.map_start = 0;             /*      Color			*/
        head.map_length = 0;            /*      Map			*/
	head.map_bits = 0;
        break;

    default:
        fprintf(stderr, "img->nb_planes = %d\n", img->nb_planes);
        fatal_error("Tga_save_image: unknow type");
        break;
    }

/*
 *	2 octobre 2001 - prise en main du BOUTISME
 *	5 oct 01: il faudrait faire une fonction genre 'ecrire_header_tga'
 */
fwrite (&head.text_size, 1, 1, fp);
fwrite (&head.is_color_map, 1, 1, fp);
fwrite (&head.type, 1, 1, fp);
Image_basicIO_write_I_short(fp, head.map_start);
Image_basicIO_write_I_short(fp, head.map_length);
fwrite (&head.map_bits, 1, 1, fp);
Image_basicIO_write_I_short(fp, head.x_start);
Image_basicIO_write_I_short(fp, head.y_start);
Image_basicIO_write_I_short(fp, head.width);
Image_basicIO_write_I_short(fp, head.height);
fwrite (&head.bits, 1, 1, fp);
fwrite (&head.flags, 1, 1, fp);

/*      if we have a comment, write it to the file			*/
if (ltxt)
    fwrite(img->comment, 1, ltxt, fp);

if ((buffer=(U_BYTE *)malloc(sizeof(U_BYTE)*4*img->width)) == NULL)
    fatal_error("no memory buffer for save operation");

/*      Ahem, now, write all the picture datas to the file...		*/ 
for (line=(img->height-1); line>=0; line--)
    {
    switch (img->nb_planes)
        {
        case    1:
            fwrite(img->Rpix[line], 1, img->width, fp);
            break;

        case    3:
            Rptr = img->Rpix[line];
            Gptr = img->Gpix[line];
            Bptr = img->Bpix[line];
            ptr = buffer;
            for (foo=0; foo<img->width; foo++)
                {
                *ptr++ = Bptr[foo];
                *ptr++ = Gptr[foo];
                *ptr++ = Rptr[foo];
                }
            fwrite(buffer, 3, img->width, fp);
            break;

        case    4:
            Rptr = img->Rpix[line];
            Gptr = img->Gpix[line];
            Bptr = img->Bpix[line];
            Aptr = img->Apix[line];
            ptr = buffer;
            for (foo=0; foo<img->width; foo++)
                {
                *ptr++ = Bptr[foo];
                *ptr++ = Gptr[foo];
                *ptr++ = Rptr[foo];
                *ptr++ = Aptr[foo];
                }
            fwrite(buffer, 4, img->width, fp);
            break;

        default:
            fatal_error("TGA save image: unknow type...");
            break;

        }
    }

free(buffer);			/* 1 Fev 00 */
img->modified   = 0;
if (fp != stdout)	fclose(fp);

return OLL_KORRECT;
}
/*::------------------------------------------------------------------::*/
/*   new 31 Jan 2002
 *   save one of the component as a gray TGA file
 *
 *	1 mars 2002: in fact, it was a palettized 8 bits file
 *
 */
int
Image_TGA_save_component(char *nom, Image_Desc *img, char channel, int comp)
{
int		ltxt, line, foo;
FILE		*fp;
U_BYTE		colormap[256*3];
Tga_file_header	head;

if (img->control != 0xdeadbeef)
	{
	fprintf(stderr, "TGASAVE: need Dead Beef!\n");
	return NOT_AN_IMAGE_DESC;
	}

if ( (fp=fopen(nom, "wb")) == NULL )
    {
    fatal_error("save image: err fopen");
    }

ltxt = strlen(img->comment);

head.text_size    = ltxt;
head.x_start      = head.y_start = 0;
head.width        = img->width;
head.height       = img->height;
head.is_color_map = 1;

head.flags        = 0;                  /* XXX  a preciser ... */
head.type         = 3;			/* Grayscale Image */
head.map_start	  = 0;
head.map_length	  = 256;
head.map_bits	  = 24;
head.bits         = 8;

fwrite (&head.text_size, 1, 1, fp);
fwrite (&head.is_color_map, 1, 1, fp);
fwrite (&head.type, 1, 1, fp);
Image_basicIO_write_I_short(fp, head.map_start);
Image_basicIO_write_I_short(fp, head.map_length);
fwrite (&head.map_bits, 1, 1, fp);
Image_basicIO_write_I_short(fp, head.x_start);
Image_basicIO_write_I_short(fp, head.y_start);
Image_basicIO_write_I_short(fp, head.width);
Image_basicIO_write_I_short(fp, head.height);
fwrite (&head.bits, 1, 1, fp);
fwrite (&head.flags, 1, 1, fp);

/* if we have a comment, write it to the file */
if (ltxt) fwrite(img->comment, 1, ltxt, fp);

/* now, populate the colormap */
for (foo=0; foo<256; foo++)
	{
	colormap[foo*3+0] = foo;
	colormap[foo*3+1] = foo;
	colormap[foo*3+2] = foo;
	}
/* and write the colormap */
fwrite (colormap, 256, 3, fp);

for (line=(img->height-1); line>=0; line--)
	{
	switch (channel)
		{
		case 'r': case 'R':
            		fwrite(img->Rpix[line], 1, img->width, fp);
			break;
		case 'g': case 'G':
            		fwrite(img->Gpix[line], 1, img->width, fp);
			break;
		case 'b': case 'B':
            		fwrite(img->Bpix[line], 1, img->width, fp);
			break;
		}
	}

fclose(fp);
fprintf(stderr, "AIE! this func (tga save component as gray) is bogus\n");

return FUNC_NOT_FINISH;
}
/*::------------------------------------------------------------------::*/
/* new 17 mars 2007 */
int
Image_TGA_print_header(Tga_file_header *ph)
{
if (NULL == ph)
	{
	fprintf(stderr, "null head ptr in '%s'\n", __func__);
	return 1;
	}
printf("+-- TGA v %s header @ %p ---\n", LIBTGA_VERSION, ph);
printf("|  comment size        %d\n", ph->text_size);
printf("|  is color map ?      %d\n", ph->is_color_map);
printf("|  type                %d\n", ph->type);
printf("|  map start           %d\n", ph->map_start);
printf("|  map length          %d\n", ph->map_length);
printf("|  map bits            %d\n", ph->map_bits);
printf("|  x start             %d\n", ph->x_start);
printf("|  y start             %d\n", ph->y_start);
printf("|  width               %d\n", ph->width);
printf("|  height              %d\n", ph->height);
printf("|  nbr of bits         %d\n", ph->bits);
printf("+---------------------------\n");
return 0;
}
/*::------------------------------------------------------------------::*/
/* new 13 mars 2007 */
int
Image_TGA_read_header(FILE *fp, void *pvoid)
{
Tga_file_header *phead;
int		foo;

phead = (Tga_file_header *)pvoid;

foo = fread(&phead->text_size, 1, 1, fp);
if (foo != 1)
	{
	fprintf(stderr, "TGA READ HEAD: err read first byte of header\n");
	return VERY_STRANGE;
	}
fread(&phead->is_color_map, 1, 1, fp);
fread(&phead->type, 1, 1, fp);
foo = Image_basicIO_read_I_short(fp, &phead->map_start);
/* fprintf(stderr, "foo=%d\n", foo); */
Image_basicIO_read_I_short(fp, &phead->map_length);
fread(&phead->map_bits, 1, 1, fp);
Image_basicIO_read_I_short(fp, &phead->x_start);
Image_basicIO_read_I_short(fp, &phead->y_start);

phead->width = phead->height = -1;
Image_basicIO_read_I_short(fp, &phead->width);
Image_basicIO_read_I_short(fp, &phead->height);
if ( (phead->width<1) || (phead->width<1) )
	{
	fprintf(stderr, "HEAD TGA: dimension < 1: %d %d\n",
					phead->width, phead->height);
	return VERY_STRANGE;
	}

fread(&phead->bits, 1, 1, fp);
if ( fread(&phead->flags, 1, 1, fp) != 1)
	{
	fprintf(stderr, "HEAD TGA: end of file before time...\n");
	return VERY_STRANGE;
	}

#if DEBUG_LEVEL
printf("comment size        %d\n", phead->text_size);
printf("is color map ?      %d\n", phead->is_color_map);
printf("type                %d\n", phead->type);
printf("map start           %d\n", phead->map_start);
printf("map length          %d\n", phead->map_length);
printf("map bits            %d\n", phead->map_bits);
printf("x start             %d\n", phead->x_start);
printf("y start             %d\n", phead->y_start);
printf("width               %d\n", phead->width);
printf("height              %d\n", phead->height);
printf("nbr of bits         %d\n", phead->bits);
#endif

return FUNC_NOT_FINISH;
}
/*::------------------------------------------------------------------::*/
/* new 13 mars 2007 */
int
Image_TGA_get_dims(char *path, int *pwidth, int *pheight)
{
FILE		*fp;
Tga_file_header	head;
int		foo;

*pwidth = *pheight = 0;

if ( (fp=fopen(path, "rb")) == NULL )
	{
	fprintf(stderr, "TGA READ HEADER: file '%s' not readable\n", path);
        return FILE_NOT_FOUND;
	}

foo = Image_TGA_read_header(fp, &head);
printf("lecture header -> %d\n", foo);

fclose(fp);

*pwidth  = (int)head.width;
*pheight = (int)head.height;

return OLL_KORRECT;
}
/*::------------------------------------------------------------------::*/
/*
 *		pour le moment, cette fonction ne charge
 *		que les images RGB. il manque le GRIS !!!
 *		! il manque aussi la decompression !
 */
Image_Desc *
Image_TGA_alloc_load(char *nom)
{
Tga_file_header     head;
FILE                *fp;
Image_Desc          *image = NULL;
U_BYTE              *buffer;
int                 ligne, ligne2, col, foo, alpha;
int                 imagetype;

if ( (fp=fopen(nom, "rb")) == NULL )
	{
	fprintf(stderr, "TGA LOAD: file '%s' not readable\n", nom);
        return NULL;
	}
 
foo = fread(&head.text_size, 1, 1, fp);
if (foo != 1)
	{
	fprintf(stderr, "TGA LOAD: err read first byte of header\n");
	fclose(fp);
	return NULL;
	}

fread(&head.is_color_map, 1, 1, fp);
fread(&head.type, 1, 1, fp);
foo = Image_basicIO_read_I_short(fp, &head.map_start);
/* fprintf(stderr, "foo=%d\n", foo); */
Image_basicIO_read_I_short(fp, &head.map_length);
fread(&head.map_bits, 1, 1, fp);
Image_basicIO_read_I_short(fp, &head.x_start);
Image_basicIO_read_I_short(fp, &head.y_start);

head.width = head.height = -1;
Image_basicIO_read_I_short(fp, &head.width);
Image_basicIO_read_I_short(fp, &head.height);
if ( (head.width<1) || (head.width<1) )
	{
	fprintf(stderr, "lecture TGA: dimension < 1: %d %d\n",
					head.width, head.height);
	fclose(fp);
	return NULL;
	}

fread(&head.bits, 1, 1, fp);
if ( fread(&head.flags, 1, 1, fp) != 1)
	{
	fprintf(stderr, "lecture TGA: fin de fichier avant le moment...\n");
	fclose(fp);
	return NULL;
	}

#if DEBUG_LEVEL
printf("comment size        %d\n", head.text_size);
printf("is color map ?      %d\n", head.is_color_map);
printf("type                %d\n", head.type);
printf("map start           %d\n", head.map_start);
printf("map length          %d\n", head.map_length);
printf("map bits            %d\n", head.map_bits);
printf("x start             %d\n", head.x_start);
printf("y start             %d\n", head.y_start);
printf("width               %d\n", head.width);
printf("height              %d\n", head.height);
printf("nbr of bits         %d\n", head.bits);
#endif

switch (head.type)
    {
    case 2:
#if DEBUG_LEVEL
        fprintf(stderr, "load file %s, type 2, %d bits\n", nom, head.map_bits);
#endif

	if (head.bits == 24)
		{
		alpha = 0;	imagetype = IMAGE_RGB;
		}
	else	
		{
		alpha = 1;	imagetype = IMAGE_RGBA;
		}

        if ( (image=Image_alloc(head.width, head.height, 3+alpha))==NULL)
            fatal_error("no memory for picture in 'alloc_load'\n");
        if ( (buffer=(U_BYTE *)malloc(4*head.width))==NULL)
            fatal_error("no memory for buffer in 'alloc_load'\n");

#if DEBUG_LEVEL
        fprintf(stderr, "      ... mem allocated\n");

        if (head.flags & 0x20)
            fprintf(stderr, "flags= 0x%02x Upside-Down ?\n", head.flags);
        if (head.flags & 0x10)
            fprintf(stderr, "flags= 0x%02x Left-Right ?\n", head.flags);
#endif

        if (head.text_size)
            {
#if DEBUG_LEVEL
            fprintf(stderr,"Skipping %d bytes of comment\n",head.text_size);
#endif
            fseek(fp, (long)head.text_size, SEEK_CUR);
            }

        for (ligne=0; ligne<head.height; ligne++)
            {
            foo=fread(buffer, 3+alpha, head.width, fp);
            if (!(head.flags & 0x20)) ligne2 = head.height - ligne - 1;
            else                      ligne2 = ligne;
            for (col=0; col<head.width; col++)
                {
                (image->Bpix[ligne2])[col] = buffer[ col*(3+alpha) ];
                (image->Gpix[ligne2])[col] = buffer[ col*(3+alpha) + 1 ];
                (image->Rpix[ligne2])[col] = buffer[ col*(3+alpha) + 2 ];
		if (alpha)
                    (image->Apix[ligne2])[col] = buffer[ col*4 + 3 ];

                }
            }

#if DEBUG_LEVEL
        fprintf(stderr, "      ... image loaded\n\n");
#endif

        break;

    default:

        fprintf(stderr, "Tga_alloc_load: file '%s' type %d not supported\n\n",
                              nom,    head.type);
        fclose (fp);
        return NULL;

    }

free(buffer);		/* added 17 May 2001 :) */
fclose(fp);

/*-------- image is in memory... return @ of descriptor to caller.	*/

return image;
}
/*::------------------------------------------------------------------::*/
				/* c'est la fin... drink a beer :) */
